------------------
-- Quest Logger --
------------------

qlQuestText = {};
qlQuestGiverGreetings = {};

local questGiverName = "";


function PlayTune()
	-- How the magic all happens :)
	PlaySoundFile("Sound\\QuestSpeak\\Test2.mp3")
	-- PlayMusic("Sound\\QuestSpeak\\Weather1.mp3")
	-- StopMusic();
end

local function SaveGreeting(greeting)
	local index = 1;

	questGiverName = UnitName("target");
	-- Init greeting variables
	if (questGiverName == nil) then
		return;
	end
	if (qlQuestGiverGreetings[questGiverName] == nil) then
		qlQuestGiverGreetings[questGiverName] = {}
	end
	-- Scan for the first available index
	while (qlQuestGiverGreetings[questGiverName][index] ~= nil) do
		if (qlQuestGiverGreetings[questGiverName][index].Text == greeting) then
			-- We already have this quest text
			return;
		end
		index = index + 1;
	end
	-- Save greeting
	qlQuestGiverGreetings[questGiverName][index] = {};
	qlQuestGiverGreetings[questGiverName][index].Text = greeting;
	qlQuestGiverGreetings[questGiverName][index].Class = UnitClass("player");
	qlQuestGiverGreetings[questGiverName][index].Race = UnitRace("player");
end

local function GossipShowEvent()
	local hasQuests = ((GetGossipAvailableQuests() ~= nil) or (GetGossipActiveQuests() ~= nil));
	if (not hasQuests) then
		return;
	end
	SaveGreeting(GetGossipText());
end

local function QuestGreetingEvent()
	SaveGreeting(name, GetGreetingText());
end

local function AddObjective(quest, objective, questText)
	local me = UnitName("player");
	local index = 1;

	if (quest["Objective"] == nil) then
		quest["Objective"] = { }
	end

	-- Scan for the first available index
	while (quest["Objective"][index] ~= nil) do
		if (quest["Objective"][index].Objective == objective) then
			-- We already have this quest text
			return;
		end
		index = index + 1;
	end
	quest["Objective"][index] = {};
	quest["Objective"][index].Class = UnitClass("player");
	quest["Objective"][index].Race = UnitRace("player");
	quest["Objective"][index].Objective = objective;
	quest["Objective"][index].QuestText = string.gsub(questText, me, "[NAME]");
end

local function InitQuest(title)
	if (questGiverName == nil) or (questGiverName == "") then
		questGiverName = UnitName("target");
		if (questGiverName == nil) then
			return false;
		end
	end

	if (qlQuestText[questGiverName] == nil) then
		qlQuestText[questGiverName] = {}
	end


	if (qlQuestText[questGiverName][title] == nil) then
		qlQuestText[questGiverName][title] = {};
	end

	return true;
end

local function QuestDetailsEvent()
	local objective = GetObjectiveText(); -- Gets the title of an available quest (only available after QUEST_GREETING event).
	local text = GetQuestText();
	local title = GetTitleText();

	if (not InitQuest(title)) then
		return;
	end

	-- Always update these, encase blizzard changes something
	AddObjective(qlQuestText[questGiverName][title], objective, text);
end

local function AddProgressCompleted(quest, category, text)
	local me = UnitName("player");
	local index = 1;

	if (quest[category] == nil) then
		quest[category] = { }
	end

	-- Scan for the first available index
	while (quest[category][index] ~= nil) do
		if (quest[category][index].Text == text) then
			-- We already have this quest text
			return;
		end
		index = index + 1;
	end
	quest[category][index] = {};
	quest[category][index].Class = UnitClass("player");
	quest[category][index].Race = UnitRace("player");
	quest[category][index].Text = string.gsub(text, me, "[NAME]");
end

local function QuestProgressEvent()
	-- Get details
	local title = GetTitleText();
	local text = GetProgressText();
	questGiverName = UnitName("target");

	if (not InitQuest(title)) then
		return;
	end

	-- Save the progresss line
	AddProgressCompleted(qlQuestText[questGiverName][title], "Progress", text)
end

local function QuestCompleteEvent()
	local text = GetRewardText();
	local title = GetTitleText();

	if (not InitQuest(title)) then
		return;
	end
	
	AddProgressCompleted(qlQuestText[questGiverName][title], "Completed", text);
end

-- Create a dummy window to capture the events
QuestLoggerFrame = CreateFrame("Frame", nil, UIParent);
QuestLoggerFrame:Show();
QuestLoggerFrame:RegisterEvent("GOSSIP_SHOW");
QuestLoggerFrame:RegisterEvent("QUEST_PROGRESS");
QuestLoggerFrame:RegisterEvent("QUEST_COMPLETE");
QuestLoggerFrame:RegisterEvent("QUEST_GREETING");
QuestLoggerFrame:RegisterEvent("QUEST_DETAIL");
QuestLoggerFrame:SetScript("OnEvent", function(self, event, a, b, c)
	if (event == "QUEST_GREETING") then
		QuestGreetingEvent();
	elseif (event == "GOSSIP_SHOW") then
		GossipShowEvent();
	elseif (event == "QUEST_COMPLETE") then
		QuestCompleteEvent();
	elseif (event == "QUEST_PROGRESS") then
		QuestProgressEvent();
	elseif (event == "QUEST_DETAIL") then
		QuestDetailsEvent();
	end
end);

